#ifndef __SPEECH_SYNTHESIZER_H__
#define __SPEECH_SYNTHESIZER_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#include "audioconfig.h"
#include "config.h"
#include "error.h"
#include "result.h"

typedef struct _SpeechSynthesizerSession SpeechSynthesizerSession;

SpeechSynthesizerSession *speech_synthesizer_create_session();
void speech_synthesizer_destroy_session(SpeechSynthesizerSession **session);
int speech_synthesizer_init_session(SpeechSynthesizerSession *session);

void speech_synthesizer_set_audio_config(SpeechSynthesizerSession *session,
                                         AudioConfig *audio_config);
void speech_synthesizer_set_model_config(SpeechSynthesizerSession *session,
                                         SpeechModelConfig *config);
void speech_synthesizer_result_set_callback(
    SpeechSynthesizerSession *session, SpeechSynthesisResultCallback callback,
    void *user_data);

void speech_synthesizer_synthesize_text_async(SpeechSynthesizerSession *session,
                                              const char *text,
                                              uint32_t text_length);

int speech_synthesizer_stop_speaking(SpeechSynthesizerSession *session);

#ifdef __cplusplus
}
#endif

#endif
